#==============================================================================
#
#  $Id$
#
"""
   Utility functions used by multiple code generation templates.
"""
#
#  Copyright (C) 2005 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#==============================================================================

from model import *

def makeCPPName(defn):
   """
      Generates and returns the fully qualified C++ name of a definition.
   """
   # for all outer contexts this returns nothing
   if not isinstance(defn, Definition):
      return ''
   elif defn.parent:
      parentName = makeCPPName(defn.parent)
   else:
      parentName = ''

   if parentName:
      return '%s::%s' % (parentName, defn.name)
   else:
      return defn.name

