
#include "Camera.h"
#include <iostream>

Camera::Camera() : yaw(0), pitch(0), origin(0, 0, 0) {
}

void Camera::rotate(Float yawDelta, Float pitchDelta) {
   yaw = normalDegrees(yaw + yawDelta);
   pitch = normalDegrees(pitch + pitchDelta);

   // create a rotation matrix for the given yaw and pitch
   RotMatrix a, b, c;
   a.makeIdent();
   b.makeYaw(-yaw);
   c.makeProduct(a, b);
   a.makePitch(-pitch);
   rotation.makeProduct(a, c);
}
