#ifndef COLOR_H
#define COLOR_H

#include "basictypes.h"

/**
 * A color descriptor.  Color values for red, green, and blue values range
 * from 0 to 1.
 */
class Color {
   public:
      Float red, green, blue;

      /** 
       * Default constructor.  The color values will be undefined and must be
       * set explicitly.
       */
      Color() {}

      Color(Float red, Float green, Float blue) : 
	 red(red), 
	 green(green), 
	 blue(blue) {
      }

      bool operator ==(const Color &other) const {
	 return red == other.red && green == other.green && 
	    blue == other.blue;
      }
};

#endif
