#ifndef COLORMATERIAL_H
#define COLORMATERIAL_H

#include "Material.h"
#include "Color.h"

/**
 * A material that renders a flat color.
 */
class ColorMaterial : public Material {
   private:
      Color color;

   public:
      /**
       * Constructs the color material given a color.
       */
      ColorMaterial(const Color &color) : color(color) {}

      virtual void makeCurrent();
      virtual void setCoord(const Vector &point);
};

#endif
