/*===========================================================================*\

   $Id$

   BitmapFont implementation file.   

   Copyright (C) 2003 Michael A. Muller

   Permission is granted to use, modify and redistribute this code,
   providing that the following conditions are met:

   1) This copyright/licensing notice must remain intact.
   2) If the code is modified and redistributed, the modifications must 
   include documentation indicating that the code has been modified.
   3) The author(s) of this code must be indemnified and held harmless
   against any damage resulting from the use of this code.

   This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
   warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

\*===========================================================================*/

#include "Font.h"
#include <GL/gl.h>
#include <GL/glx.h>

BitmapFont::BitmapFont(const char *name) : listBase(0) {
   Display *display = XOpenDisplay(NULL);
   XFontStruct *fontInfo = XLoadQueryFont(display, name);
   if (!fontInfo) {
      XCloseDisplay(display);
      throw InvalidFontError(name);
   }

   // allocate the display list
   listBase = glGenLists(96);
   std::cout << "listBase = " << listBase << std::endl;

   // transfer the font from X to GL
   glXUseXFont(fontInfo->fid, 32, 96, listBase);

   // release the display and the X font memory
   XFreeFont(display, fontInfo);
   XCloseDisplay(display);
}

BitmapFont::~BitmapFont() {
   glDeleteLists(listBase, 96);
}

void BitmapFont::setBase() {
   glListBase(listBase - 32);
}
