#ifndef GAMEOBJECT_H
#define GAMEOBJECT_H

#include <spug/RCBase.h>
#include <spug/RCPtr.h>
#include "basictypes.h"

class GameEngine;

/**
 * Any object in the game.  The defining characteristic of a GameObject is
 * that it included in the GameEngine's main loop.
 */
class GameObject : public virtual spug::RCBase {
   public:

      /**
       * Called every engine frame.  Allows a game object to define its own
       * behavior.  Base class version does nothing.
       */
      virtual void processEngineFrame(GameEngine &engine);

      /**
       * Called every rendering frame.  Base class version does nothing.
       *
       * @param elapsed elapsed time since the last frame in seconds
       */
      virtual void processRenderFrame(GameEngine &engine, Float elapsed);
};

SPUG_RCPTR(GameObject);

#endif
