
#include "Graphics.h"
#include "Font.h"
#include <GL/gl.h>

Graphics Graphics::instance;

Graphics::Graphics() : fixed(0) {}

Graphics::~Graphics() {
   if (fixed)
      delete fixed;
}

void Graphics::initialize(int width, int height) {
   glViewport(0, 0, width, height);

   glClearColor(0, 0, 0, 0);
   glClearDepth(1.0);
   glShadeModel(GL_SMOOTH);
   glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
   glEnable(GL_DEPTH_TEST);
   glEnable(GL_TEXTURE_2D);
   glDepthFunc(GL_LEQUAL);
   glEnable(GL_LIGHTING);
   glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
}

void Graphics::enableLighting(bool enabled) {
   if (enabled)
      glEnable(GL_LIGHTING);
   else
      glDisable(GL_LIGHTING);
}

void Graphics::drawText(const char *text) {
   glPushAttrib(GL_LIST_BIT);
   if (!fixed)
      fixed = new BitmapFont();
   fixed->setBase();
   glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);
   glPopAttrib();
}

void Graphics::moveTo(Float x, Float y) {
   glRasterPos2f(x, y);
}

void Graphics::setColor(const Color &color) {
   glColor<Float>(color.red, color.green, color.blue);
}
