
#ifndef GRAPHICS_H
#define GRAPHICS_H

#include "basictypes.h"
#include "Color.h"

class BitmapFont;

class Graphics {
   private:
      static Graphics instance;

      // the default font
      BitmapFont *fixed;

   public:

      Graphics();

      ~Graphics();

      /** Returns the graphics singleton. */
      static Graphics &getInstance() {
	 return instance;
      }

      /**
       * Perform all GL one-time initialization functions.
       */
      void initialize(int width, int height);

      /**
       * Enable (or disable) lighting.
       */
      void enableLighting(bool enabled = true);

      /**
       * Draw the given text at the current position.
       */
      void drawText(const char *text);

      /** Move to a 2-d position on the raster display. */
      void moveTo(Float x, Float y);

      /** Sets the current drawing color */
      void setColor(const Color &color);
};

#endif
