
#include "Light.h"

#include "Color.h"

Light::Light(const Vector &pos, const Color &color, Float mystery, 
             bool diffuse) :
   pos(pos), 
   diffuse(diffuse) {

   rep[0] = color.red;
   rep[1] = color.green;
   rep[2] = color.blue;
   rep[3] = mystery;
}

void Light::render(Scene &scene) {
   GLfloat ambient[] = { 0.5, 0.5, 0.5, 1.0 };
   glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);
   glLightfv(GL_LIGHT0, diffuse ? GL_DIFFUSE : GL_AMBIENT, rep);
   GLfloat posArr[] = { pos.x, pos.y, pos.z, 1.0 };
   //GLfloat posArr[] = { 0, 0, 0, 1.0 };
   glLightfv(GL_LIGHT0, GL_POSITION, posArr);

   GLfloat atten = 0;
   glLightfv(GL_LIGHT0, GL_CONSTANT_ATTENUATION, &atten);
   atten = 1;
   glLightfv(GL_LIGHT0, GL_LINEAR_ATTENUATION, &atten);
   glLightfv(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, &atten);

   glEnable(GL_LIGHT0);
}
