#ifndef LIGHT_H
#define LIGHT_H

#include "Moveable.h"
#include <GL/gl.h>

class Color;

/**
 * A light source.
 */
class Light : public Moveable {
   private:
      // light description - red, green, blue and (???)
      GLfloat rep[4];

      // true if diffuse, false means ambient
      bool diffuse;

      // position of the light
      Vector pos;

   public:

      Light(const Vector &pos, const Color &color, Float mystery = 1.0, 
            bool diffuse = true
            );

      virtual void render(Scene &scene);
};

#endif
