#ifndef OBJECT_H
#define OBJECT_H

#include <spug/RCBase.h>

/**
   Base class of all objects in the system.

   Objects are reference counted and persistable.
 */
class Object : public spug::RCBase {

   public:

      /**
	 Stores the object on the given writer.
       */
      virtual void store(Writer &writer) = 0;

      /**
	 Loads the object from the given reader.
       */
      virtual ObjectPtr load(Reader &reader);
};

#endif
