#ifndef PYTHONPLUGIN_H
#define PYTHONPLUGIN_H

#include <spug/Exception.h>

class DisplayDriver;
class GameEngine;

SPUG_EXCEPTION(PluginError);

class PythonPlugin {
   private:
      static DisplayDriver *displayDriver;
      friend DisplayDriver *getDisplayDriver();
      static GameEngine *gameEngine;
      friend GameEngine *getGameEngine();
   public:
      void setDisplayDriver(DisplayDriver *displayDriver);
      void setGameEngine(GameEngine *gameEngine);
      void handleInit();
      void handleTerminate();
};

#endif
