
#include "QuadObj.h"

#include <iostream>
#include "PNG.h"
using namespace std;

void QuadObj::render(Scene &scene) {


#if 0
   // translate and rotate all coordinates to the position and orientation of 
   // the scene
   Vector org = scene.getOrigin();
   const RotMatrix &rot = scene.getRotMatrix();
   Vector c0, c1, c2, c3;
   rot.rotate(coord0 - org, c0);
   rot.rotate(coord1 - org, c1);
   rot.rotate(coord2 - org, c2);
   rot.rotate(coord3 - org, c3);

   if (scene.includes(c0) || scene.includes(c1) || scene.includes(c2) ||
       scene.includes(c3)
       ) {
      glColor<Float>(color.x, color.y, color.z);
      glBegin(GL_POLYGON);
	 glVertex(c0.x, c0.y, -c0.z);
	 glVertex(c1.x, c1.y, -c1.z);
	 glVertex(c2.x, c2.y, -c2.z);
	 glVertex(c3.x, c3.y, -c3.z);
      glEnd();
   }
#else

   // set the surface material
   material->makeCurrent();

   glBegin(GL_QUADS);
      Vector norm = normal();
      glNormal<Float>(norm.x, norm.y, norm.z);
      material->setCoord(coord0);
      glVertex(coord0.x, coord0.y, coord0.z);
      material->setCoord(coord1);
      glVertex(coord1.x, coord1.y, coord1.z);
      material->setCoord(coord2);
      glVertex(coord2.x, coord2.y, coord2.z);
      material->setCoord(coord3);
      glVertex(coord3.x, coord3.y, coord3.z);
   glEnd();
#endif
}

bool QuadObj::intersects(const Vector &origin, const Vector &direction,
			 Vector &intersection,
			 Float &distance
			 ) {
   // XXX refactor Tri::intersects so we can make this more efficient
   return 
      Tri(coord0, coord1, coord2).intersects(origin, direction, intersection, distance) ||
      Tri(coord0, coord2, coord3).intersects(origin, direction, intersection, distance);
}

AxisBox QuadObj::getBoundingBox() const {
   AxisBox box(false);
   box.expandTo(coord0);
   box.expandTo(coord1);
   box.expandTo(coord2);
   box.expandTo(coord3);

   return box;
}
