#ifndef QUADOBJ_H
#define QUADOBJ_H

#include "PolyObj.h"
#include "Quad.h"
#include "Tri.h"

/**
 * A quadrilateral PolyObj.  Defined by four points.
 */
class QuadObj : public PolyObj, public Quad {

   public:
      QuadObj(const Quad &quad, const MaterialPtr &material) : 
	 Quad(quad), 
	 PolyObj(material) {
      }

      QuadObj(Vector coord0, Vector coord1, Vector coord2, Vector coord3, 
	      const MaterialPtr &material
	      ) :
	 Quad(coord0, coord1, coord2, coord3),
	 PolyObj(material) {
      }

      // Implements Renderable
      virtual void render(Scene &scene);

      // Implements PolyObj
      virtual Vector normal() const {
	 return Tri::normal(coord0, coord1, coord2);
      }

      // Implements PolyObj
      virtual bool intersects(const Vector &origin, const Vector &direction,
			      Vector &intersection,
			      Float &distance
	                      );

      // Implements PolyObj
      virtual AxisBox getBoundingBox() const;
};

typedef spug::RCPtr<QuadObj> QuadObjPtr;

#endif
