#ifndef RENDERABLEOBJECT_H
#define RENDERABLEOBJECT_H

#include <spug/RCPtr.h>
#include <spug/RCBase.h>
#include "Scene.h"

/**
   Base class for all renderable objects.

   For most of the "lightweight" object types (e.g. Quad, Poly, Tri) there is
   a heavyweight RenderableObject derivative which has the same basic
   properties plus a suite of virtual functions for rendering.
 */
class RenderableObject : public virtual spug::RCBase {

   public:

      /**
	 Renders the object onto the scene.
       */
      virtual void render(Scene &scene) = 0;

};

typedef spug::RCPtr<RenderableObject> RenderableObjectPtr;

#endif
