
#include "Scene.h"
#include <GL/gl.h>

Scene::Scene(const Vector &origin, const RotMatrix &orientation, 
             Float maxDistance
             ) :
   org(origin),
   rot(orientation),
   maxDistance(maxDistance) {
   Vector tmp(0, 0, -1);
   rot.rotate(tmp, direction);
}

void Scene::mapToCamera() const {
   // translate the rotation matrix to the opengl rotation matrix
   Float rotMatrix[4][4];
   rot.getGLMatrix(rotMatrix);

   // translate and rotate the camera view
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   glFrustum(-xfact, xfact, -yfact, yfact, 1, maxDistance);
   glMultMatrix<Float>(rotMatrix);
   glTranslate(-org.x, -org.y, -org.z);
   glMatrixMode(GL_MODELVIEW);
}
