#ifndef TEXTURE_H
#define TEXTURE_H

#include <spug/RCBase.h>
#include <spug/RCPtr.h>
#include <GL/gl.h>

/** Keeps track of a texture.  */
class Texture : public spug::RCBase {

   private:
      std::string fileName;
      unsigned textureId;
      unsigned width, height;

      // don't want to copy these - always use a reference
      Texture(const Texture &other);

   public:
      Texture(const char *fileName);

      virtual ~Texture();

      void load();

      unsigned getWidth() {
	 if (!textureId) load();
	 return width;
      }

      unsigned getHeight() {
	 if (!textureId) load();
	 return height;
      }
      void makeCurrent() {
	 // load the texture if we haven't already
	 if (!textureId) load();

	 // make it the current texture
	 glBindTexture(GL_TEXTURE_2D, textureId);
      }
};

SPUG_RCPTR(Texture);

#endif
