
#include "TextureMaterial.h"
#include "Color.h"
#include "basictypes.h"

void TextureMaterial::makeCurrent() {
   glColor<Float>(1, 1, 1);
   tex->makeCurrent();
   state = 0;
   lastCoord = Vector(0, 0, 0);
   xpos = ypos = 0;
}

void TextureMaterial::setCoord(const Vector &coord) {

   // get the distance from the last point
   Float dist = (coord - lastCoord).size();

   // XXX ignore the coordinate for now and just assume that points will be
   // rendered counter-clockwise from the top left of the texture
   switch (state) {
      case 0:
	 glTexCoord<Float>(0, 1);
	 break;
      case 1:
	 xpos = dist * xscale;
	 glTexCoord<Float>(xpos, 1);
	 break;
      case 2:
	 ypos = 1 - dist * yscale;
	 glTexCoord<Float>(xpos, ypos);
	 break;
      case 3:
	 glTexCoord<Float>(0, ypos);
	 break;
   }

   // rotate the state
   ++state %= 4;

   // store the last coordinate
   lastCoord = coord;
}
