#ifndef TRI_H
#define TRI_H

#include "Vector.h"

/**
 * Basic form of a triangle - three sets of coordinates.
 */
class Tri {
   Vector coord0, coord1, coord2;

   public:
      Tri() {}

      Tri(const Vector &coord0, const Vector &coord1, const Vector &coord2) :
	 coord0(coord0), coord1(coord1), coord2(coord2) {
      }

      /**
       * Static function which returns the normal of three points.
       */
      static Vector normal(const Vector &coord0, const Vector &coord1,
			   const Vector &coord2
			   );

      /** Returns the normal of the triangle. */
      Vector normal() const {
	 return normal(coord0, coord1, coord2);
      }

      /** 
       * Returns true if the ray defined by the given origin and direction
       * intersects the triangle.
       *
       * If there is an intersection, the "intersection" variable contains the
       * point of the intersection and "distance" contains its value.  If
       * there is no intersection, these values are undefined.
       */
      bool intersects(const Vector &org, const Vector &dir, 
		      Vector &intersection,
		      Float &distance
		      ) const;
};

#endif
