#ifndef WURLDSDLDRIVER_H
#define WURLDSDLDRIVER_H

#include "DisplayDriver.h"
#include <SDL.h>

class GameEngine;
class MouseHandler;

class WurldSDLDriver : public DisplayDriver {
   private:
      SDL_Surface *surface;
      GameEngine &engine;
      MouseHandler &mouseHandler;
      bool terminated;
      int initWidth, initHeight;

      void render();
      void shutdown();
      void handleKeyPress(int keyCode);

      void handleKeyRelease(int keyCode);

      void handleMouseMove(int x, int y);

   public:
      WurldSDLDriver(GameEngine &engine, MouseHandler &mouseHandler);

      virtual int main(int argc, const char **argv);

      virtual void setDisplaySize(int width, int height);

      virtual Size getSize() const;

      virtual void hideMouse();

      virtual void warpMouse(int x, int y);

      virtual void grabMouse(bool grab = true);
};

#endif
