#==============================================================================
#
#  $Id$
#
"""
   Script to draw a bent tube coming out of the floor.
"""
#
#  Copyright (C) 2007 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#==============================================================================

import wurld
from turtle import *
from util import *

# create a material to use
material = wurld.createTextureMaterial(wurld.createTexture('PlasmaVomit.png'),
				       10,
				       10
				       )

# create the tool and the turtle
tool = CrossSectionTool(material, drawSquareXSect)
turtle = Turtle(tool)

# draw the elbow
turtle.pitch(90)
turtle.stamp()
turtle.forward(10, False)
turtle.pitch(45)
turtle.stamp()
turtle.forward(10)

# display it
showModel(tool.model)

