
#include <iostream>
#include "Vector.h"
#include "RotMatrix.h"
#include "QuadObj.h"
#include "ColorMaterial.h"

using namespace std;

main() {
   Vector p(1, 0, 0), q;
   cout << p << endl;
   RotMatrix roll90, roll180, pitch90, yaw90;
   roll90.makeRoll(90);
   pitch90.makePitch(90);
   yaw90.makeYaw(90);

   roll90.rotate(p, q);
   cout << "roll 90 = " << q << endl;

   roll180.makeProduct(roll90, roll90);
   roll180.rotate(p, q);
   cout << "roll 180 = " << q << endl;

   pitch90.rotate(p, q);
   cout << "pitch 90 = " << q << endl;

   yaw90.rotate(p, q);
   cout << "yaw 90 = " << q << endl;

   PolyObjPtr quadObj = 
      new QuadObj(
	 Vector(0, 0, 0),
	 Vector(0, 0, 1),
	 Vector(1, 0, 1),
	 Vector(1, 0, 0),
	 new ColorMaterial(Color(1, 1, 1))
      );
   cout << "normal = " << quadObj->normal() << endl;
}
