#==============================================================================
#
#  $Id$
#
"""
   The wurld bootstrapping script.
"""
#
#  Copyright (C) 2007 Michael A. Muller
#
#  Permission is granted to use, modify and redistribute this code,
#  providing that the following conditions are met:
#
#  1) This copyright/licensing notice must remain intact.
#  2) If the code is modified and redistributed, the modifications must 
#  include documentation indicating that the code has been modified.
#  3) The author(s) of this code must be indemnified and held harmless
#  against any damage resulting from the use of this code.
#
#  This code comes with ABSOLUTELY NO WARRANTEE, not even the implied 
#  warrantee of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
#
#==============================================================================

import wurld
import sys, os
sys.path.insert(0, '.')
import turtle

# set the display resolution
wurld.getDisplayDriver().setDisplaySize(640, 480)

# this allows us to set the lighting after opengl has been initialized
firstFrame = True
def globalCallback(engine, obj):
   global firstFrame
   if firstFrame:
      wurld.getGraphics().enableLighting(True)
      firstFrame = False

obj = wurld.createPythonObject()
obj.setEngineFrameCallback(globalCallback)
wurld.getGameEngine().addGameObject(obj)

# add everything in the gameobjs directory
for file in os.listdir('gameobjs'):
   # ... except any pesky maintenence files
   if not file.startswith('.'):
      execfile(os.path.join('gameobjs', file), {})

print '=' * 78
print 'Finished wurldrc.py'
print '=' * 78
